#include <stdio.h>
#include <sys/mman.h>
#include <fcntl.h>
main(int argc, char **argv)
{
	char *map;
	unsigned long address;
	unsigned long base;
	int fd;
	char *tmp;
	if (argc != 2) {
		fprintf(stderr, "gimme a kernel address\n");
		exit(1);
	}
	address = strtoul(argv[1], &tmp, 0);

	fd = open("kmem", O_RDONLY);
	if (fd < 0) {
		perror("open kmem, if noent, mknob kmem c 1 2\n");
		exit(1);
	}
	base = address & ~4095;
	map = mmap(0, 8192, PROT_READ, MAP_SHARED, fd, base);
	if (map == MAP_FAILED) {
		perror("mmap kmem");
		exit(1);
	}
	write(1, map + (address - base), 40);
	return (0);
}
