
#ifndef __KERNEL__
#  define __KERNEL__
#endif
#ifndef MODULE
#  define MODULE
#endif

//#include <linux/config.h>
#include <linux/module.h>

#include <linux/kernel.h>
#include <linux/proc_fs.h>
#include <linux/vmalloc.h>
#include <asm/pgtable.h>
MODULE_LICENSE("GPL");
char * scratch;
static int
ncall_read_proc(char *buf, char **start, off_t offset,
		int count, int *eof, void *data)
{
	int len=0;
	len=sprintf(buf, "0x%x\n", scratch);
	*eof = 1;
	return len;
}

//#ifndef __PAGE_KERNEL_EXEC
//#define __PAGE_KERNEL_EXEC 0x63
//#endif
int direct_init_module(void)
{
	struct proc_dir_entry *ncall =
	    create_proc_entry("scratch0", 0666, NULL);
	ncall->read_proc = ncall_read_proc;
//	scratch=vmalloc_exec(8192);
	scratch=__vmalloc(8192, GFP_KERNEL | __GFP_HIGHMEM, 
//	PAGE_KERNEL_EXEC
	__pgprot(__PAGE_KERNEL & ~_PAGE_NX)
);

	memcpy(scratch, "SCRATCH\x00", 8);
	return 0;
}

void direct_cleanup_module(void)
{
	remove_proc_entry("scratch0", NULL);
//	vfree(scratch);
}

module_init(direct_init_module);
module_exit(direct_cleanup_module);
